/* xnoise-mpris.c generated by valac 0.10.0, the Vala compiler
 * generated from xnoise-mpris.vala, do not modify */

/* xnoise-mpris.vala
 *
 * Copyright (C) 2010 Andreas Obergrusberger
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The Xnoise authors hereby grant permission for non-GPL compatible
 *  GStreamer plugins to be used and distributed together with GStreamer
 *  and Xnoise. This permission is above and beyond the permissions granted
 *  by the GPL license by which Xnoise is covered. If you modify this code
 *  you may extend this exception to your version of the code, but you are not
 *  obligated to do so. If you do not wish to do so, delete this exception
 *  statement from your version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA.
 *
 * Author:
 * Andreas Obergrusberger
 * Jörn Magens
 */
/* exposes xnoise's player and tracklist controls via dbus using the mpris v2 interface*/
/* refer to */
/* http://www.mpris.org/2.0/spec/*/

#include <glib.h>
#include <glib-object.h>
#include <xnoise.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <float.h>
#include <math.h>


#define XNOISE_TYPE_MPRIS (xnoise_mpris_get_type ())
#define XNOISE_MPRIS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), XNOISE_TYPE_MPRIS, XnoiseMpris))
#define XNOISE_MPRIS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), XNOISE_TYPE_MPRIS, XnoiseMprisClass))
#define XNOISE_IS_MPRIS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), XNOISE_TYPE_MPRIS))
#define XNOISE_IS_MPRIS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), XNOISE_TYPE_MPRIS))
#define XNOISE_MPRIS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), XNOISE_TYPE_MPRIS, XnoiseMprisClass))

typedef struct _XnoiseMpris XnoiseMpris;
typedef struct _XnoiseMprisClass XnoiseMprisClass;
typedef struct _XnoiseMprisPrivate XnoiseMprisPrivate;

#define TYPE_MPRIS_PLAYER (mpris_player_get_type ())
#define MPRIS_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MPRIS_PLAYER, MprisPlayer))
#define MPRIS_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MPRIS_PLAYER, MprisPlayerClass))
#define IS_MPRIS_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MPRIS_PLAYER))
#define IS_MPRIS_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MPRIS_PLAYER))
#define MPRIS_PLAYER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MPRIS_PLAYER, MprisPlayerClass))

typedef struct _MprisPlayer MprisPlayer;
typedef struct _MprisPlayerClass MprisPlayerClass;

#define TYPE_MPRIS_ROOT (mpris_root_get_type ())
#define MPRIS_ROOT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MPRIS_ROOT, MprisRoot))
#define MPRIS_ROOT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MPRIS_ROOT, MprisRootClass))
#define IS_MPRIS_ROOT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MPRIS_ROOT))
#define IS_MPRIS_ROOT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MPRIS_ROOT))
#define MPRIS_ROOT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MPRIS_ROOT, MprisRootClass))

typedef struct _MprisRoot MprisRoot;
typedef struct _MprisRootClass MprisRootClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _MprisRootPrivate MprisRootPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _MprisPlayerPrivate MprisPlayerPrivate;

#define MPRIS_PLAYER_TYPE_DIRECTION (mpris_player_direction_get_type ())
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_variant_type_free0(var) ((var == NULL) ? NULL : (var = (g_variant_type_free (var), NULL)))
#define _g_list_free0(var) ((var == NULL) ? NULL : (var = (g_list_free (var), NULL)))
#define _g_variant_builder_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_builder_unref (var), NULL)))

struct _XnoiseMpris {
	GObject parent_instance;
	XnoiseMprisPrivate * priv;
	MprisPlayer* player;
	MprisRoot* root;
};

struct _XnoiseMprisClass {
	GObjectClass parent_class;
};

struct _XnoiseMprisPrivate {
	XnoiseMain* _xn;
	guint owner_id;
};

struct _MprisRoot {
	GObject parent_instance;
	MprisRootPrivate * priv;
};

struct _MprisRootClass {
	GObjectClass parent_class;
};

struct _MprisRootPrivate {
	XnoiseMain* xn;
};

struct _MprisPlayer {
	GObject parent_instance;
	MprisPlayerPrivate * priv;
};

struct _MprisPlayerClass {
	GObjectClass parent_class;
};

struct _MprisPlayerPrivate {
	XnoiseMain* xn;
	GDBusConnection* conn;
	guint send_property_source;
	guint update_metadata_source;
	GHashTable* changed_properties;
	XnoiseMainWindowRepeat buffer_repeat_state;
	GHashTable* _metadata;
};

typedef enum  {
	MPRIS_PLAYER_DIRECTION_NEXT = 0,
	MPRIS_PLAYER_DIRECTION_PREVIOUS,
	MPRIS_PLAYER_DIRECTION_STOP
} MprisPlayerDirection;


static gpointer xnoise_mpris_parent_class = NULL;
static XnoiseIPluginIface* xnoise_mpris_xnoise_iplugin_parent_iface = NULL;
static GType xnoise_mpris_type_id = 0;
static gpointer mpris_root_parent_class = NULL;
static GType mpris_root_type_id = 0;
static gpointer mpris_player_parent_class = NULL;
static GType mpris_player_type_id = 0;

GType xnoise_mpris_get_type (void) G_GNUC_CONST;
GType xnoise_mpris_register_type (GTypeModule * module);
GType mpris_player_get_type (void) G_GNUC_CONST;
GType mpris_player_register_type (GTypeModule * module);
guint mpris_player_register_object (void* object, GDBusConnection* connection, const gchar* path, GError** error);
GType mpris_root_get_type (void) G_GNUC_CONST;
GType mpris_root_register_type (GTypeModule * module);
guint mpris_root_register_object (void* object, GDBusConnection* connection, const gchar* path, GError** error);
#define XNOISE_MPRIS_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), XNOISE_TYPE_MPRIS, XnoiseMprisPrivate))
enum  {
	XNOISE_MPRIS_DUMMY_PROPERTY,
	XNOISE_MPRIS_XN,
	XNOISE_MPRIS_NAME
};
static void xnoise_mpris_on_bus_acquired (XnoiseMpris* self, GDBusConnection* connection, const char* name);
MprisRoot* mpris_root_new (void);
MprisRoot* mpris_root_construct (GType object_type);
MprisPlayer* mpris_player_new (GDBusConnection* conn);
MprisPlayer* mpris_player_construct (GType object_type, GDBusConnection* conn);
static void xnoise_mpris_on_name_acquired (XnoiseMpris* self, GDBusConnection* connection, const char* name);
static void xnoise_mpris_on_name_lost (XnoiseMpris* self, GDBusConnection* connection, const char* name);
static gboolean xnoise_mpris_real_init (XnoiseIPlugin* base);
static void _xnoise_mpris_on_bus_acquired_gbus_acquired_callback (GDBusConnection* connection, const char* name, gpointer self);
static void _xnoise_mpris_on_name_acquired_gbus_name_acquired_callback (GDBusConnection* connection, const char* name, gpointer self);
static void _xnoise_mpris_on_name_lost_gbus_name_lost_callback (GDBusConnection* connection, const char* name, gpointer self);
static GtkWidget* xnoise_mpris_real_get_settings_widget (XnoiseIPlugin* base);
static GtkWidget* xnoise_mpris_real_get_singleline_settings_widget (XnoiseIPlugin* base);
static gboolean xnoise_mpris_real_has_settings_widget (XnoiseIPlugin* base);
static gboolean xnoise_mpris_real_has_singleline_settings_widget (XnoiseIPlugin* base);
XnoiseMpris* xnoise_mpris_new (void);
XnoiseMpris* xnoise_mpris_construct (GType object_type);
static void xnoise_mpris_finalize (GObject* obj);
static void xnoise_mpris_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void xnoise_mpris_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
#define MPRIS_ROOT_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_MPRIS_ROOT, MprisRootPrivate))
enum  {
	MPRIS_ROOT_DUMMY_PROPERTY,
	MPRIS_ROOT_CAN_QUIT,
	MPRIS_ROOT_CAN_RAISE,
	MPRIS_ROOT_HAS_TRACK_LIST,
	MPRIS_ROOT_DESKTOP_ENTRY,
	MPRIS_ROOT_IDENTITY,
	MPRIS_ROOT_SUPPORTED_URI_SCHEMES,
	MPRIS_ROOT_SUPPORTED_MIME_TYPES
};
void mpris_root_Quit (MprisRoot* self);
void mpris_root_Raise (MprisRoot* self);
gboolean mpris_root_get_CanQuit (MprisRoot* self);
gboolean mpris_root_get_CanRaise (MprisRoot* self);
gboolean mpris_root_get_HasTrackList (MprisRoot* self);
const char* mpris_root_get_DesktopEntry (MprisRoot* self);
const char* mpris_root_get_Identity (MprisRoot* self);
char** mpris_root_get_SupportedUriSchemes (MprisRoot* self, int* result_length1);
char** mpris_root_get_SupportedMimeTypes (MprisRoot* self, int* result_length1);
static void mpris_root_finalize (GObject* obj);
static void mpris_root_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void mpris_root_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data);
static void _dbus_mpris_root_Quit (MprisRoot* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_mpris_root_Raise (MprisRoot* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static GVariant* mpris_root_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data);
static GVariant* _dbus_mpris_root_get_CanQuit (MprisRoot* self);
static GVariant* _dbus_mpris_root_get_CanRaise (MprisRoot* self);
static GVariant* _dbus_mpris_root_get_HasTrackList (MprisRoot* self);
static GVariant* _dbus_mpris_root_get_DesktopEntry (MprisRoot* self);
static GVariant* _dbus_mpris_root_get_Identity (MprisRoot* self);
static GVariant* _dbus_mpris_root_get_SupportedUriSchemes (MprisRoot* self);
static GVariant* _dbus_mpris_root_get_SupportedMimeTypes (MprisRoot* self);
static gboolean mpris_root_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data);
static void _mpris_root_unregister_object (gpointer user_data);
#define MPRIS_PLAYER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_MPRIS_PLAYER, MprisPlayerPrivate))
enum  {
	MPRIS_PLAYER_DUMMY_PROPERTY,
	MPRIS_PLAYER_PLAYBACK_STATUS,
	MPRIS_PLAYER_LOOP_STATUS,
	MPRIS_PLAYER_RATE,
	MPRIS_PLAYER_SHUFFLE,
	MPRIS_PLAYER_METADATA,
	MPRIS_PLAYER_VOLUME,
	MPRIS_PLAYER_POSITION,
	MPRIS_PLAYER_MINIMUM_RATE,
	MPRIS_PLAYER_MAXIMUM_RATE,
	MPRIS_PLAYER_CAN_GO_NEXT,
	MPRIS_PLAYER_CAN_GO_PREVIOUS,
	MPRIS_PLAYER_CAN_PLAY,
	MPRIS_PLAYER_CAN_PAUSE,
	MPRIS_PLAYER_CAN_SEEK,
	MPRIS_PLAYER_CAN_CONTROL
};
static GType mpris_player_direction_get_type (void) G_GNUC_UNUSED;
#define MPRIS_PLAYER_INTERFACE_NAME "org.mpris.MediaPlayer2.Player"
static void _lambda0_ (GObject* s, GParamSpec* p, MprisPlayer* self);
char* mpris_player_get_PlaybackStatus (MprisPlayer* self);
static GVariant* _variant_new1 (char* value);
static void mpris_player_queue_property_for_notification (MprisPlayer* self, const char* property, GVariant* val);
static void __lambda0__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
static void mpris_player_on_tag_changed (MprisPlayer* self, XnoiseGlobalAccess* sender, char** newuri, const char* tagname, const char* tagvalue);
static void _mpris_player_on_tag_changed_xnoise_global_access_tag_changed (XnoiseGlobalAccess* _sender, char** newuri, const char* tagname, const char* tagvalue, gpointer self);
static void _lambda2_ (MprisPlayer* self);
static GVariant* _variant_new2 (double value);
static void __lambda2__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
static void _lambda3_ (MprisPlayer* self);
static GVariant* _variant_new3 (const char* value);
static GVariant* _variant_new4 (char* value);
static void mpris_player_trigger_metadata_update (MprisPlayer* self);
static void __lambda3__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
static void _lambda4_ (MprisPlayer* self);
static GVariant* _variant_new5 (gint64 value);
static gint64 _variant_get6 (GVariant* value);
static GVariant* _variant_new7 (gint64 value);
static void __lambda4__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
static gboolean _lambda1_ (MprisPlayer* self);
static GVariant* _variant_new8 (char* value);
static gboolean __lambda1__gsource_func (gpointer self);
static void _vala_array_add1 (char*** array, int* length, int* size, char* value);
static GVariant* _variant_new9 (char** value, gint value_length1);
static GVariant* _variant_new10 (const char* value);
static GVariant* _variant_new11 (const char* value);
static void _vala_array_add2 (char*** array, int* length, int* size, char* value);
static GVariant* _variant_new12 (char** value, gint value_length1);
static gboolean mpris_player_send_property_change (MprisPlayer* self);
static gboolean _mpris_player_send_property_change_gsource_func (gpointer self);
void mpris_player_Next (MprisPlayer* self);
void mpris_player_Previous (MprisPlayer* self);
void mpris_player_Pause (MprisPlayer* self);
void mpris_player_PlayPause (MprisPlayer* self);
void mpris_player_Stop (MprisPlayer* self);
void mpris_player_Play (MprisPlayer* self);
void mpris_player_Seek (MprisPlayer* self, gint64 Offset);
void mpris_player_SetPosition (MprisPlayer* self, const char* dobj, gint64 Position);
void mpris_player_OpenUri (MprisPlayer* self, const char* Uri);
char* mpris_player_get_LoopStatus (MprisPlayer* self);
void mpris_player_set_LoopStatus (MprisPlayer* self, const char* value);
static GVariant* _variant_new13 (const char* value);
double mpris_player_get_Rate (MprisPlayer* self);
void mpris_player_set_Rate (MprisPlayer* self, double value);
gboolean mpris_player_get_Shuffle (MprisPlayer* self);
void mpris_player_set_Shuffle (MprisPlayer* self, gboolean value);
static GVariant* _variant_new14 (gboolean value);
GHashTable* mpris_player_get_Metadata (MprisPlayer* self);
static GVariant* _variant_new15 (const char* value);
double mpris_player_get_Volume (MprisPlayer* self);
void mpris_player_set_Volume (MprisPlayer* self, double value);
gint64 mpris_player_get_Position (MprisPlayer* self);
double mpris_player_get_MinimumRate (MprisPlayer* self);
double mpris_player_get_MaximumRate (MprisPlayer* self);
gboolean mpris_player_get_CanGoNext (MprisPlayer* self);
gboolean mpris_player_get_CanGoPrevious (MprisPlayer* self);
gboolean mpris_player_get_CanPlay (MprisPlayer* self);
gboolean mpris_player_get_CanPause (MprisPlayer* self);
gboolean mpris_player_get_CanSeek (MprisPlayer* self);
gboolean mpris_player_get_CanControl (MprisPlayer* self);
static void mpris_player_finalize (GObject* obj);
static void mpris_player_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void mpris_player_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static void mpris_player_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data);
static void _dbus_mpris_player_Next (MprisPlayer* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_mpris_player_Previous (MprisPlayer* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_mpris_player_Pause (MprisPlayer* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_mpris_player_PlayPause (MprisPlayer* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_mpris_player_Stop (MprisPlayer* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_mpris_player_Play (MprisPlayer* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_mpris_player_Seek (MprisPlayer* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_mpris_player_SetPosition (MprisPlayer* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_mpris_player_OpenUri (MprisPlayer* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static GVariant* mpris_player_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data);
static GVariant* _dbus_mpris_player_get_PlaybackStatus (MprisPlayer* self);
static GVariant* _dbus_mpris_player_get_LoopStatus (MprisPlayer* self);
static GVariant* _dbus_mpris_player_get_Rate (MprisPlayer* self);
static GVariant* _dbus_mpris_player_get_Shuffle (MprisPlayer* self);
static GVariant* _dbus_mpris_player_get_Metadata (MprisPlayer* self);
static GVariant* _dbus_mpris_player_get_Volume (MprisPlayer* self);
static GVariant* _dbus_mpris_player_get_Position (MprisPlayer* self);
static GVariant* _dbus_mpris_player_get_MinimumRate (MprisPlayer* self);
static GVariant* _dbus_mpris_player_get_MaximumRate (MprisPlayer* self);
static GVariant* _dbus_mpris_player_get_CanGoNext (MprisPlayer* self);
static GVariant* _dbus_mpris_player_get_CanGoPrevious (MprisPlayer* self);
static GVariant* _dbus_mpris_player_get_CanPlay (MprisPlayer* self);
static GVariant* _dbus_mpris_player_get_CanPause (MprisPlayer* self);
static GVariant* _dbus_mpris_player_get_CanSeek (MprisPlayer* self);
static GVariant* _dbus_mpris_player_get_CanControl (MprisPlayer* self);
static gboolean mpris_player_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data);
static void _dbus_mpris_player_set_LoopStatus (MprisPlayer* self, GVariant* _value);
static void _dbus_mpris_player_set_Rate (MprisPlayer* self, GVariant* _value);
static void _dbus_mpris_player_set_Shuffle (MprisPlayer* self, GVariant* _value);
static void _dbus_mpris_player_set_Volume (MprisPlayer* self, GVariant* _value);
static void _dbus_mpris_player_seeked (GObject* _sender, gint64 Position, gpointer* _data);
static void _mpris_player_unregister_object (gpointer user_data);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static int _vala_strcmp0 (const char * str1, const char * str2);

static const GDBusArgInfo * const _mpris_root_dbus_arg_info_Quit_in[] = {NULL};
static const GDBusArgInfo * const _mpris_root_dbus_arg_info_Quit_out[] = {NULL};
static const GDBusMethodInfo _mpris_root_dbus_method_info_Quit = {-1, "Quit", (GDBusArgInfo **) (&_mpris_root_dbus_arg_info_Quit_in), (GDBusArgInfo **) (&_mpris_root_dbus_arg_info_Quit_out)};
static const GDBusArgInfo * const _mpris_root_dbus_arg_info_Raise_in[] = {NULL};
static const GDBusArgInfo * const _mpris_root_dbus_arg_info_Raise_out[] = {NULL};
static const GDBusMethodInfo _mpris_root_dbus_method_info_Raise = {-1, "Raise", (GDBusArgInfo **) (&_mpris_root_dbus_arg_info_Raise_in), (GDBusArgInfo **) (&_mpris_root_dbus_arg_info_Raise_out)};
static const GDBusMethodInfo * const _mpris_root_dbus_method_info[] = {&_mpris_root_dbus_method_info_Quit, &_mpris_root_dbus_method_info_Raise, NULL};
static const GDBusSignalInfo * const _mpris_root_dbus_signal_info[] = {NULL};
static const GDBusPropertyInfo _mpris_root_dbus_property_info_CanQuit = {-1, "CanQuit", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE};
static const GDBusPropertyInfo _mpris_root_dbus_property_info_CanRaise = {-1, "CanRaise", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE};
static const GDBusPropertyInfo _mpris_root_dbus_property_info_HasTrackList = {-1, "HasTrackList", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE};
static const GDBusPropertyInfo _mpris_root_dbus_property_info_DesktopEntry = {-1, "DesktopEntry", "s", G_DBUS_PROPERTY_INFO_FLAGS_READABLE};
static const GDBusPropertyInfo _mpris_root_dbus_property_info_Identity = {-1, "Identity", "s", G_DBUS_PROPERTY_INFO_FLAGS_READABLE};
static const GDBusPropertyInfo _mpris_root_dbus_property_info_SupportedUriSchemes = {-1, "SupportedUriSchemes", "as", G_DBUS_PROPERTY_INFO_FLAGS_READABLE};
static const GDBusPropertyInfo _mpris_root_dbus_property_info_SupportedMimeTypes = {-1, "SupportedMimeTypes", "as", G_DBUS_PROPERTY_INFO_FLAGS_READABLE};
static const GDBusPropertyInfo * const _mpris_root_dbus_property_info[] = {&_mpris_root_dbus_property_info_CanQuit, &_mpris_root_dbus_property_info_CanRaise, &_mpris_root_dbus_property_info_HasTrackList, &_mpris_root_dbus_property_info_DesktopEntry, &_mpris_root_dbus_property_info_Identity, &_mpris_root_dbus_property_info_SupportedUriSchemes, &_mpris_root_dbus_property_info_SupportedMimeTypes, NULL};
static const GDBusInterfaceInfo _mpris_root_dbus_interface_info = {-1, "org.mpris.MediaPlayer2", (GDBusMethodInfo **) (&_mpris_root_dbus_method_info), (GDBusSignalInfo **) (&_mpris_root_dbus_signal_info), (GDBusPropertyInfo **) (&_mpris_root_dbus_property_info)};
static const GDBusInterfaceVTable _mpris_root_dbus_interface_vtable = {mpris_root_dbus_interface_method_call, mpris_root_dbus_interface_get_property, mpris_root_dbus_interface_set_property};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_Next_in[] = {NULL};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_Next_out[] = {NULL};
static const GDBusMethodInfo _mpris_player_dbus_method_info_Next = {-1, "Next", (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_Next_in), (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_Next_out)};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_Previous_in[] = {NULL};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_Previous_out[] = {NULL};
static const GDBusMethodInfo _mpris_player_dbus_method_info_Previous = {-1, "Previous", (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_Previous_in), (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_Previous_out)};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_Pause_in[] = {NULL};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_Pause_out[] = {NULL};
static const GDBusMethodInfo _mpris_player_dbus_method_info_Pause = {-1, "Pause", (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_Pause_in), (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_Pause_out)};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_PlayPause_in[] = {NULL};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_PlayPause_out[] = {NULL};
static const GDBusMethodInfo _mpris_player_dbus_method_info_PlayPause = {-1, "PlayPause", (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_PlayPause_in), (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_PlayPause_out)};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_Stop_in[] = {NULL};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_Stop_out[] = {NULL};
static const GDBusMethodInfo _mpris_player_dbus_method_info_Stop = {-1, "Stop", (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_Stop_in), (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_Stop_out)};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_Play_in[] = {NULL};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_Play_out[] = {NULL};
static const GDBusMethodInfo _mpris_player_dbus_method_info_Play = {-1, "Play", (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_Play_in), (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_Play_out)};
static const GDBusArgInfo _mpris_player_dbus_arg_info_Seek_Offset = {-1, "Offset", "x"};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_Seek_in[] = {&_mpris_player_dbus_arg_info_Seek_Offset, NULL};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_Seek_out[] = {NULL};
static const GDBusMethodInfo _mpris_player_dbus_method_info_Seek = {-1, "Seek", (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_Seek_in), (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_Seek_out)};
static const GDBusArgInfo _mpris_player_dbus_arg_info_SetPosition_dobj = {-1, "dobj", "s"};
static const GDBusArgInfo _mpris_player_dbus_arg_info_SetPosition_Position = {-1, "Position", "x"};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_SetPosition_in[] = {&_mpris_player_dbus_arg_info_SetPosition_dobj, &_mpris_player_dbus_arg_info_SetPosition_Position, NULL};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_SetPosition_out[] = {NULL};
static const GDBusMethodInfo _mpris_player_dbus_method_info_SetPosition = {-1, "SetPosition", (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_SetPosition_in), (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_SetPosition_out)};
static const GDBusArgInfo _mpris_player_dbus_arg_info_OpenUri_Uri = {-1, "Uri", "s"};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_OpenUri_in[] = {&_mpris_player_dbus_arg_info_OpenUri_Uri, NULL};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_OpenUri_out[] = {NULL};
static const GDBusMethodInfo _mpris_player_dbus_method_info_OpenUri = {-1, "OpenUri", (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_OpenUri_in), (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_OpenUri_out)};
static const GDBusMethodInfo * const _mpris_player_dbus_method_info[] = {&_mpris_player_dbus_method_info_Next, &_mpris_player_dbus_method_info_Previous, &_mpris_player_dbus_method_info_Pause, &_mpris_player_dbus_method_info_PlayPause, &_mpris_player_dbus_method_info_Stop, &_mpris_player_dbus_method_info_Play, &_mpris_player_dbus_method_info_Seek, &_mpris_player_dbus_method_info_SetPosition, &_mpris_player_dbus_method_info_OpenUri, NULL};
static const GDBusArgInfo _mpris_player_dbus_arg_info_seeked_Position = {-1, "Position", "x"};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_seeked[] = {&_mpris_player_dbus_arg_info_seeked_Position, NULL};
static const GDBusSignalInfo _mpris_player_dbus_signal_info_seeked = {-1, "Seeked", (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_seeked)};
static const GDBusSignalInfo * const _mpris_player_dbus_signal_info[] = {&_mpris_player_dbus_signal_info_seeked, NULL};
static const GDBusPropertyInfo _mpris_player_dbus_property_info_PlaybackStatus = {-1, "PlaybackStatus", "s", G_DBUS_PROPERTY_INFO_FLAGS_READABLE};
static const GDBusPropertyInfo _mpris_player_dbus_property_info_LoopStatus = {-1, "LoopStatus", "s", G_DBUS_PROPERTY_INFO_FLAGS_READABLE | G_DBUS_PROPERTY_INFO_FLAGS_WRITABLE};
static const GDBusPropertyInfo _mpris_player_dbus_property_info_Rate = {-1, "Rate", "d", G_DBUS_PROPERTY_INFO_FLAGS_READABLE | G_DBUS_PROPERTY_INFO_FLAGS_WRITABLE};
static const GDBusPropertyInfo _mpris_player_dbus_property_info_Shuffle = {-1, "Shuffle", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE | G_DBUS_PROPERTY_INFO_FLAGS_WRITABLE};
static const GDBusPropertyInfo _mpris_player_dbus_property_info_Metadata = {-1, "Metadata", "a{sv}", G_DBUS_PROPERTY_INFO_FLAGS_READABLE};
static const GDBusPropertyInfo _mpris_player_dbus_property_info_Volume = {-1, "Volume", "d", G_DBUS_PROPERTY_INFO_FLAGS_READABLE | G_DBUS_PROPERTY_INFO_FLAGS_WRITABLE};
static const GDBusPropertyInfo _mpris_player_dbus_property_info_Position = {-1, "Position", "x", G_DBUS_PROPERTY_INFO_FLAGS_READABLE};
static const GDBusPropertyInfo _mpris_player_dbus_property_info_MinimumRate = {-1, "MinimumRate", "d", G_DBUS_PROPERTY_INFO_FLAGS_READABLE};
static const GDBusPropertyInfo _mpris_player_dbus_property_info_MaximumRate = {-1, "MaximumRate", "d", G_DBUS_PROPERTY_INFO_FLAGS_READABLE};
static const GDBusPropertyInfo _mpris_player_dbus_property_info_CanGoNext = {-1, "CanGoNext", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE};
static const GDBusPropertyInfo _mpris_player_dbus_property_info_CanGoPrevious = {-1, "CanGoPrevious", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE};
static const GDBusPropertyInfo _mpris_player_dbus_property_info_CanPlay = {-1, "CanPlay", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE};
static const GDBusPropertyInfo _mpris_player_dbus_property_info_CanPause = {-1, "CanPause", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE};
static const GDBusPropertyInfo _mpris_player_dbus_property_info_CanSeek = {-1, "CanSeek", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE};
static const GDBusPropertyInfo _mpris_player_dbus_property_info_CanControl = {-1, "CanControl", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE};
static const GDBusPropertyInfo * const _mpris_player_dbus_property_info[] = {&_mpris_player_dbus_property_info_PlaybackStatus, &_mpris_player_dbus_property_info_LoopStatus, &_mpris_player_dbus_property_info_Rate, &_mpris_player_dbus_property_info_Shuffle, &_mpris_player_dbus_property_info_Metadata, &_mpris_player_dbus_property_info_Volume, &_mpris_player_dbus_property_info_Position, &_mpris_player_dbus_property_info_MinimumRate, &_mpris_player_dbus_property_info_MaximumRate, &_mpris_player_dbus_property_info_CanGoNext, &_mpris_player_dbus_property_info_CanGoPrevious, &_mpris_player_dbus_property_info_CanPlay, &_mpris_player_dbus_property_info_CanPause, &_mpris_player_dbus_property_info_CanSeek, &_mpris_player_dbus_property_info_CanControl, NULL};
static const GDBusInterfaceInfo _mpris_player_dbus_interface_info = {-1, "org.mpris.MediaPlayer2.Player", (GDBusMethodInfo **) (&_mpris_player_dbus_method_info), (GDBusSignalInfo **) (&_mpris_player_dbus_signal_info), (GDBusPropertyInfo **) (&_mpris_player_dbus_property_info)};
static const GDBusInterfaceVTable _mpris_player_dbus_interface_vtable = {mpris_player_dbus_interface_method_call, mpris_player_dbus_interface_get_property, mpris_player_dbus_interface_set_property};

static void g_cclosure_user_marshal_VOID__INT64 (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);

static void xnoise_mpris_on_bus_acquired (XnoiseMpris* self, GDBusConnection* connection, const char* name) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (connection != NULL);
	g_return_if_fail (name != NULL);
	{
		MprisRoot* _tmp0_;
		MprisPlayer* _tmp1_;
		self->root = (_tmp0_ = mpris_root_new (), _g_object_unref0 (self->root), _tmp0_);
		mpris_root_register_object (self->root, connection, "/org/mpris/MediaPlayer2", &_inner_error_);
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_IO_ERROR) {
				goto __catch0_g_io_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
		self->player = (_tmp1_ = mpris_player_new (connection), _g_object_unref0 (self->player), _tmp1_);
		mpris_player_register_object (self->player, connection, "/org/mpris/MediaPlayer2", &_inner_error_);
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_IO_ERROR) {
				goto __catch0_g_io_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	goto __finally0;
	__catch0_g_io_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
			g_print ("%s\n", e->message);
			_g_error_free0 (e);
		}
	}
	__finally0:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static void xnoise_mpris_on_name_acquired (XnoiseMpris* self, GDBusConnection* connection, const char* name) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (connection != NULL);
	g_return_if_fail (name != NULL);
}


static void xnoise_mpris_on_name_lost (XnoiseMpris* self, GDBusConnection* connection, const char* name) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (connection != NULL);
	g_return_if_fail (name != NULL);
}


static void _xnoise_mpris_on_bus_acquired_gbus_acquired_callback (GDBusConnection* connection, const char* name, gpointer self) {
	xnoise_mpris_on_bus_acquired (self, connection, name);
}


static void _xnoise_mpris_on_name_acquired_gbus_name_acquired_callback (GDBusConnection* connection, const char* name, gpointer self) {
	xnoise_mpris_on_name_acquired (self, connection, name);
}


static void _xnoise_mpris_on_name_lost_gbus_name_lost_callback (GDBusConnection* connection, const char* name, gpointer self) {
	xnoise_mpris_on_name_lost (self, connection, name);
}


static gboolean xnoise_mpris_real_init (XnoiseIPlugin* base) {
	XnoiseMpris * self;
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
	self = (XnoiseMpris*) base;
	{
		self->priv->owner_id = g_bus_own_name_with_closures (G_BUS_TYPE_SESSION, "org.mpris.MediaPlayer2.xnoise", G_BUS_NAME_OWNER_FLAGS_NONE, (GClosure*) g_cclosure_new ((GCallback) _xnoise_mpris_on_bus_acquired_gbus_acquired_callback, g_object_ref (self), g_object_unref), (GClosure*) g_cclosure_new ((GCallback) _xnoise_mpris_on_name_acquired_gbus_name_acquired_callback, g_object_ref (self), g_object_unref), (GClosure*) g_cclosure_new ((GCallback) _xnoise_mpris_on_name_lost_gbus_name_lost_callback, g_object_ref (self), g_object_unref));
	}
	goto __finally1;
	__catch1_g_io_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
			g_print ("%s\n", e->message);
			result = FALSE;
			_g_error_free0 (e);
			return result;
		}
	}
	__finally1:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
	result = TRUE;
	return result;
}


static GtkWidget* xnoise_mpris_real_get_settings_widget (XnoiseIPlugin* base) {
	XnoiseMpris * self;
	GtkWidget* result = NULL;
	self = (XnoiseMpris*) base;
	result = NULL;
	return result;
}


static GtkWidget* xnoise_mpris_real_get_singleline_settings_widget (XnoiseIPlugin* base) {
	XnoiseMpris * self;
	GtkWidget* result = NULL;
	self = (XnoiseMpris*) base;
	result = NULL;
	return result;
}


static gboolean xnoise_mpris_real_has_settings_widget (XnoiseIPlugin* base) {
	XnoiseMpris * self;
	gboolean result = FALSE;
	self = (XnoiseMpris*) base;
	result = FALSE;
	return result;
}


static gboolean xnoise_mpris_real_has_singleline_settings_widget (XnoiseIPlugin* base) {
	XnoiseMpris * self;
	gboolean result = FALSE;
	self = (XnoiseMpris*) base;
	result = FALSE;
	return result;
}


XnoiseMpris* xnoise_mpris_construct (GType object_type) {
	XnoiseMpris * self;
	self = (XnoiseMpris*) g_object_new (object_type, NULL);
	return self;
}


XnoiseMpris* xnoise_mpris_new (void) {
	return xnoise_mpris_construct (XNOISE_TYPE_MPRIS);
}


static XnoiseMain* xnoise_mpris_real_get_xn (XnoiseIPlugin* base) {
	XnoiseMain* result;
	XnoiseMpris* self;
	self = (XnoiseMpris*) base;
	result = self->priv->_xn;
	return result;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void xnoise_mpris_real_set_xn (XnoiseIPlugin* base, XnoiseMain* value) {
	XnoiseMpris* self;
	XnoiseMain* _tmp0_;
	self = (XnoiseMpris*) base;
	self->priv->_xn = (_tmp0_ = _g_object_ref0 (value), _g_object_unref0 (self->priv->_xn), _tmp0_);
	g_object_notify ((GObject *) self, "xn");
}


static const char* xnoise_mpris_real_get_name (XnoiseIPlugin* base) {
	const char* result;
	XnoiseMpris* self;
	self = (XnoiseMpris*) base;
	result = "mpris";
	return result;
}


static void xnoise_mpris_class_init (XnoiseMprisClass * klass) {
	xnoise_mpris_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (XnoiseMprisPrivate));
	G_OBJECT_CLASS (klass)->get_property = xnoise_mpris_get_property;
	G_OBJECT_CLASS (klass)->set_property = xnoise_mpris_set_property;
	G_OBJECT_CLASS (klass)->finalize = xnoise_mpris_finalize;
	g_object_class_override_property (G_OBJECT_CLASS (klass), XNOISE_MPRIS_XN, "xn");
	g_object_class_override_property (G_OBJECT_CLASS (klass), XNOISE_MPRIS_NAME, "name");
}


static void xnoise_mpris_xnoise_iplugin_interface_init (XnoiseIPluginIface * iface) {
	xnoise_mpris_xnoise_iplugin_parent_iface = g_type_interface_peek_parent (iface);
	iface->init = xnoise_mpris_real_init;
	iface->get_settings_widget = xnoise_mpris_real_get_settings_widget;
	iface->get_singleline_settings_widget = xnoise_mpris_real_get_singleline_settings_widget;
	iface->has_settings_widget = xnoise_mpris_real_has_settings_widget;
	iface->has_singleline_settings_widget = xnoise_mpris_real_has_singleline_settings_widget;
	iface->get_xn = xnoise_mpris_real_get_xn;
	iface->set_xn = xnoise_mpris_real_set_xn;
	iface->get_name = xnoise_mpris_real_get_name;
}


static void xnoise_mpris_instance_init (XnoiseMpris * self) {
	self->priv = XNOISE_MPRIS_GET_PRIVATE (self);
	self->player = NULL;
	self->root = NULL;
}


static void xnoise_mpris_finalize (GObject* obj) {
	XnoiseMpris * self;
	self = XNOISE_MPRIS (obj);
	{
		g_bus_unown_name (self->priv->owner_id);
	}
	_g_object_unref0 (self->priv->_xn);
	_g_object_unref0 (self->player);
	_g_object_unref0 (self->root);
	G_OBJECT_CLASS (xnoise_mpris_parent_class)->finalize (obj);
}


GType xnoise_mpris_get_type (void) {
	return xnoise_mpris_type_id;
}


GType xnoise_mpris_register_type (GTypeModule * module) {
	static const GTypeInfo g_define_type_info = { sizeof (XnoiseMprisClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) xnoise_mpris_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (XnoiseMpris), 0, (GInstanceInitFunc) xnoise_mpris_instance_init, NULL };
	static const GInterfaceInfo xnoise_iplugin_info = { (GInterfaceInitFunc) xnoise_mpris_xnoise_iplugin_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	xnoise_mpris_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "XnoiseMpris", &g_define_type_info, 0);
	g_type_module_add_interface (module, xnoise_mpris_type_id, XNOISE_TYPE_IPLUGIN, &xnoise_iplugin_info);
	return xnoise_mpris_type_id;
}


static void xnoise_mpris_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	XnoiseMpris * self;
	self = XNOISE_MPRIS (object);
	switch (property_id) {
		case XNOISE_MPRIS_XN:
		g_value_set_object (value, xnoise_iplugin_get_xn ((XnoiseIPlugin*) self));
		break;
		case XNOISE_MPRIS_NAME:
		g_value_set_string (value, xnoise_iplugin_get_name ((XnoiseIPlugin*) self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void xnoise_mpris_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	XnoiseMpris * self;
	self = XNOISE_MPRIS (object);
	switch (property_id) {
		case XNOISE_MPRIS_XN:
		xnoise_iplugin_set_xn ((XnoiseIPlugin*) self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


MprisRoot* mpris_root_construct (GType object_type) {
	MprisRoot * self;
	self = (MprisRoot*) g_object_new (object_type, NULL);
	self->priv->xn = xnoise_main_get_instance ();
	return self;
}


MprisRoot* mpris_root_new (void) {
	return mpris_root_construct (TYPE_MPRIS_ROOT);
}


void mpris_root_Quit (MprisRoot* self) {
	g_return_if_fail (self != NULL);
	xnoise_main_quit (self->priv->xn);
}


void mpris_root_Raise (MprisRoot* self) {
	g_return_if_fail (self != NULL);
	xnoise_main_window_show_window (self->priv->xn->main_window);
}


gboolean mpris_root_get_CanQuit (MprisRoot* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = TRUE;
	return result;
}


gboolean mpris_root_get_CanRaise (MprisRoot* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = TRUE;
	return result;
}


gboolean mpris_root_get_HasTrackList (MprisRoot* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = FALSE;
	return result;
}


const char* mpris_root_get_DesktopEntry (MprisRoot* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = "xnoise";
	return result;
}


const char* mpris_root_get_Identity (MprisRoot* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = "xnoise media player";
	return result;
}


char** mpris_root_get_SupportedUriSchemes (MprisRoot* self, int* result_length1) {
	char** result;
	gint sa_length1;
	gint _sa_size_;
	char** _tmp1_;
	char** _tmp0_ = NULL;
	char** sa;
	char** _tmp2_;
	g_return_val_if_fail (self != NULL, NULL);
	sa = (_tmp1_ = (_tmp0_ = g_new0 (char*, 4 + 1), _tmp0_[0] = g_strdup ("http"), _tmp0_[1] = g_strdup ("file"), _tmp0_[2] = g_strdup ("https"), _tmp0_[3] = g_strdup ("ftp"), _tmp0_), sa_length1 = 4, _sa_size_ = sa_length1, _tmp1_);
	result = (_tmp2_ = sa, *result_length1 = sa_length1, _tmp2_);
	return result;
	sa = (_vala_array_free (sa, sa_length1, (GDestroyNotify) g_free), NULL);
}


char** mpris_root_get_SupportedMimeTypes (MprisRoot* self, int* result_length1) {
	char** result;
	gint sa_length1;
	gint _sa_size_;
	char** _tmp1_;
	char** _tmp0_ = NULL;
	char** sa;
	char** _tmp2_;
	g_return_val_if_fail (self != NULL, NULL);
	sa = (_tmp1_ = (_tmp0_ = g_new0 (char*, 45 + 1), _tmp0_[0] = g_strdup ("application/x-ogg"), _tmp0_[1] = g_strdup ("application/ogg"), _tmp0_[2] = g_strdup ("video/3gpp"), _tmp0_[3] = g_strdup ("video/avi"), _tmp0_[4] = g_strdup ("video/dv"), _tmp0_[5] = g_strdup ("video/fli"), _tmp0_[6] = g_strdup ("video/flv"), _tmp0_[7] = g_strdup ("video/mp4"), _tmp0_[8] = g_strdup ("video/mp4v-es"), _tmp0_[9] = g_strdup ("video/mpeg"), _tmp0_[10] = g_strdup ("video/msvideo"), _tmp0_[11] = g_strdup ("video/ogg"), _tmp0_[12] = g_strdup ("video/quicktime"), _tmp0_[13] = g_strdup ("video/vivo"), _tmp0_[14] = g_strdup ("video/vnd.divx"), _tmp0_[15] = g_strdup ("video/vnd.vivo"), _tmp0_[16] = g_strdup ("video/x-anim"), _tmp0_[17] = g_strdup ("video/x-avi"), _tmp0_[18] = g_strdup ("video/x-flc"), _tmp0_[19] = g_strdup ("video/x-fli"), _tmp0_[20] = g_strdup ("video/x-flic"), _tmp0_[21] = g_strdup ("video/x-flv"), _tmp0_[22] = g_strdup ("video/x-m4v"), _tmp0_[23] = g_strdup ("video/x-matroska"), _tmp0_[24] = g_strdup ("video/x-mpeg"), _tmp0_[25] = g_strdup ("video/x-mpg"), _tmp0_[26] = g_strdup ("video/x-ms-asf"), _tmp0_[27] = g_strdup ("video/x-msvideo"), _tmp0_[28] = g_strdup ("video/x-ms-wm"), _tmp0_[29] = g_strdup ("video/x-ms-wmv"), _tmp0_[30] = g_strdup ("video/x-ms-wmx"), _tmp0_[31] = g_strdup ("video/x-ms-wvx"), _tmp0_[32] = g_strdup ("video/x-nsv"), _tmp0_[33] = g_strdup ("video/x-ogm+ogg"), _tmp0_[34] = g_strdup ("video/x-theora"), _tmp0_[35] = g_strdup ("video/x-theora+ogg"), _tmp0_[36] = g_strdup ("audio/x-vorbis+ogg"), _tmp0_[37] = g_strdup ("audio/x-scpls"), _tmp0_[38] = g_strdup ("audio/x-mp3"), _tmp0_[39] = g_strdup ("audio/x-mpeg"), _tmp0_[40] = g_strdup ("audio/mpeg"), _tmp0_[41] = g_strdup ("audio/x-mpegurl"), _tmp0_[42] = g_strdup ("audio/x-flac"), _tmp0_[43] = g_strdup ("x-content/audio-cdda"), _tmp0_[44] = g_strdup ("x-content/audio-player"), _tmp0_), sa_length1 = 45, _sa_size_ = sa_length1, _tmp1_);
	result = (_tmp2_ = sa, *result_length1 = sa_length1, _tmp2_);
	return result;
	sa = (_vala_array_free (sa, sa_length1, (GDestroyNotify) g_free), NULL);
}


static void mpris_root_class_init (MprisRootClass * klass) {
	mpris_root_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (MprisRootPrivate));
	G_OBJECT_CLASS (klass)->get_property = mpris_root_get_property;
	G_OBJECT_CLASS (klass)->finalize = mpris_root_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_ROOT_CAN_QUIT, g_param_spec_boolean ("CanQuit", "CanQuit", "CanQuit", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_ROOT_CAN_RAISE, g_param_spec_boolean ("CanRaise", "CanRaise", "CanRaise", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_ROOT_HAS_TRACK_LIST, g_param_spec_boolean ("HasTrackList", "HasTrackList", "HasTrackList", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_ROOT_DESKTOP_ENTRY, g_param_spec_string ("DesktopEntry", "DesktopEntry", "DesktopEntry", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_ROOT_IDENTITY, g_param_spec_string ("Identity", "Identity", "Identity", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_ROOT_SUPPORTED_URI_SCHEMES, g_param_spec_boxed ("SupportedUriSchemes", "SupportedUriSchemes", "SupportedUriSchemes", G_TYPE_STRV, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_ROOT_SUPPORTED_MIME_TYPES, g_param_spec_boxed ("SupportedMimeTypes", "SupportedMimeTypes", "SupportedMimeTypes", G_TYPE_STRV, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
}


static void mpris_root_instance_init (MprisRoot * self) {
	self->priv = MPRIS_ROOT_GET_PRIVATE (self);
}


static void mpris_root_finalize (GObject* obj) {
	MprisRoot * self;
	self = MPRIS_ROOT (obj);
	G_OBJECT_CLASS (mpris_root_parent_class)->finalize (obj);
}


GType mpris_root_get_type (void) {
	return mpris_root_type_id;
}


GType mpris_root_register_type (GTypeModule * module) {
	static const GTypeInfo g_define_type_info = { sizeof (MprisRootClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) mpris_root_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MprisRoot), 0, (GInstanceInitFunc) mpris_root_instance_init, NULL };
	mpris_root_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "MprisRoot", &g_define_type_info, 0);
	return mpris_root_type_id;
}


static void mpris_root_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	MprisRoot * self;
	int length;
	self = MPRIS_ROOT (object);
	switch (property_id) {
		case MPRIS_ROOT_CAN_QUIT:
		g_value_set_boolean (value, mpris_root_get_CanQuit (self));
		break;
		case MPRIS_ROOT_CAN_RAISE:
		g_value_set_boolean (value, mpris_root_get_CanRaise (self));
		break;
		case MPRIS_ROOT_HAS_TRACK_LIST:
		g_value_set_boolean (value, mpris_root_get_HasTrackList (self));
		break;
		case MPRIS_ROOT_DESKTOP_ENTRY:
		g_value_set_string (value, mpris_root_get_DesktopEntry (self));
		break;
		case MPRIS_ROOT_IDENTITY:
		g_value_set_string (value, mpris_root_get_Identity (self));
		break;
		case MPRIS_ROOT_SUPPORTED_URI_SCHEMES:
		g_value_take_boxed (value, mpris_root_get_SupportedUriSchemes (self, &length));
		break;
		case MPRIS_ROOT_SUPPORTED_MIME_TYPES:
		g_value_take_boxed (value, mpris_root_get_SupportedMimeTypes (self, &length));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _dbus_mpris_root_Quit (MprisRoot* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error;
	GVariantIter _arguments_iter;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	error = NULL;
	g_variant_iter_init (&_arguments_iter, parameters);
	mpris_root_Quit (self);
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_method_invocation_return_value (invocation, _reply);
}


static void _dbus_mpris_root_Raise (MprisRoot* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error;
	GVariantIter _arguments_iter;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	error = NULL;
	g_variant_iter_init (&_arguments_iter, parameters);
	mpris_root_Raise (self);
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_method_invocation_return_value (invocation, _reply);
}


static void mpris_root_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "Quit") == 0) {
		_dbus_mpris_root_Quit (object, parameters, invocation);
	} else if (strcmp (method_name, "Raise") == 0) {
		_dbus_mpris_root_Raise (object, parameters, invocation);
	}
}


static GVariant* _dbus_mpris_root_get_CanQuit (MprisRoot* self) {
	gboolean result;
	GVariant* _reply;
	result = mpris_root_get_CanQuit (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}


static GVariant* _dbus_mpris_root_get_CanRaise (MprisRoot* self) {
	gboolean result;
	GVariant* _reply;
	result = mpris_root_get_CanRaise (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}


static GVariant* _dbus_mpris_root_get_HasTrackList (MprisRoot* self) {
	gboolean result;
	GVariant* _reply;
	result = mpris_root_get_HasTrackList (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}


static GVariant* _dbus_mpris_root_get_DesktopEntry (MprisRoot* self) {
	char* result;
	GVariant* _reply;
	result = mpris_root_get_DesktopEntry (self);
	_reply = g_variant_new_string (result);
	_g_free0 (result);
	return _reply;
}


static GVariant* _dbus_mpris_root_get_Identity (MprisRoot* self) {
	char* result;
	GVariant* _reply;
	result = mpris_root_get_Identity (self);
	_reply = g_variant_new_string (result);
	_g_free0 (result);
	return _reply;
}


static GVariant* _dbus_mpris_root_get_SupportedUriSchemes (MprisRoot* self) {
	char** result;
	GVariant* _reply;
	int result_length1;
	char** _tmp0_;
	GVariantBuilder _tmp1_;
	int _tmp2_;
	result = mpris_root_get_SupportedUriSchemes (self, &result_length1);
	_tmp0_ = result;
	g_variant_builder_init (&_tmp1_, G_VARIANT_TYPE_ARRAY);
	for (_tmp2_ = 0; _tmp2_ < result_length1; _tmp2_++) {
		g_variant_builder_add_value (&_tmp1_, g_variant_new_string (*_tmp0_));
		_tmp0_++;
	}
	_reply = g_variant_builder_end (&_tmp1_);
	result = (_vala_array_free (result,  result_length1, (GDestroyNotify) g_free), NULL);
	return _reply;
}


static GVariant* _dbus_mpris_root_get_SupportedMimeTypes (MprisRoot* self) {
	char** result;
	GVariant* _reply;
	int result_length1;
	char** _tmp3_;
	GVariantBuilder _tmp4_;
	int _tmp5_;
	result = mpris_root_get_SupportedMimeTypes (self, &result_length1);
	_tmp3_ = result;
	g_variant_builder_init (&_tmp4_, G_VARIANT_TYPE_ARRAY);
	for (_tmp5_ = 0; _tmp5_ < result_length1; _tmp5_++) {
		g_variant_builder_add_value (&_tmp4_, g_variant_new_string (*_tmp3_));
		_tmp3_++;
	}
	_reply = g_variant_builder_end (&_tmp4_);
	result = (_vala_array_free (result,  result_length1, (GDestroyNotify) g_free), NULL);
	return _reply;
}


static GVariant* mpris_root_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (property_name, "CanQuit") == 0) {
		return _dbus_mpris_root_get_CanQuit (object);
	} else if (strcmp (property_name, "CanRaise") == 0) {
		return _dbus_mpris_root_get_CanRaise (object);
	} else if (strcmp (property_name, "HasTrackList") == 0) {
		return _dbus_mpris_root_get_HasTrackList (object);
	} else if (strcmp (property_name, "DesktopEntry") == 0) {
		return _dbus_mpris_root_get_DesktopEntry (object);
	} else if (strcmp (property_name, "Identity") == 0) {
		return _dbus_mpris_root_get_Identity (object);
	} else if (strcmp (property_name, "SupportedUriSchemes") == 0) {
		return _dbus_mpris_root_get_SupportedUriSchemes (object);
	} else if (strcmp (property_name, "SupportedMimeTypes") == 0) {
		return _dbus_mpris_root_get_SupportedMimeTypes (object);
	}
	return NULL;
}


static gboolean mpris_root_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}


guint mpris_root_register_object (gpointer object, GDBusConnection* connection, const gchar* path, GError** error) {
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, &_mpris_root_dbus_interface_info, &_mpris_root_dbus_interface_vtable, data, _mpris_root_unregister_object, error);
	if (!result) {
		return 0;
	}
	return result;
}


static void _mpris_root_unregister_object (gpointer user_data) {
	gpointer* data;
	data = user_data;
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}


static GType mpris_player_direction_get_type (void) {
	static volatile gsize mpris_player_direction_type_id__volatile = 0;
	if (g_once_init_enter (&mpris_player_direction_type_id__volatile)) {
		static const GEnumValue values[] = {{MPRIS_PLAYER_DIRECTION_NEXT, "MPRIS_PLAYER_DIRECTION_NEXT", "next"}, {MPRIS_PLAYER_DIRECTION_PREVIOUS, "MPRIS_PLAYER_DIRECTION_PREVIOUS", "previous"}, {MPRIS_PLAYER_DIRECTION_STOP, "MPRIS_PLAYER_DIRECTION_STOP", "stop"}, {0, NULL, NULL}};
		GType mpris_player_direction_type_id;
		mpris_player_direction_type_id = g_enum_register_static ("MprisPlayerDirection", values);
		g_once_init_leave (&mpris_player_direction_type_id__volatile, mpris_player_direction_type_id);
	}
	return mpris_player_direction_type_id__volatile;
}


static GVariant* _variant_new1 (char* value) {
	return g_variant_ref_sink (g_variant_new_string (value));
}


static void _lambda0_ (GObject* s, GParamSpec* p, MprisPlayer* self) {
	GVariant* variant;
	g_return_if_fail (s != NULL);
	g_return_if_fail (p != NULL);
	variant = _variant_new1 (mpris_player_get_PlaybackStatus (self));
	mpris_player_queue_property_for_notification (self, "PlaybackStatus", variant);
	_g_variant_unref0 (variant);
}


static void __lambda0__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
	_lambda0_ (_sender, pspec, self);
}


static void _mpris_player_on_tag_changed_xnoise_global_access_tag_changed (XnoiseGlobalAccess* _sender, char** newuri, const char* tagname, const char* tagvalue, gpointer self) {
	mpris_player_on_tag_changed (self, _sender, newuri, tagname, tagvalue);
}


static GVariant* _variant_new2 (double value) {
	return g_variant_ref_sink (g_variant_new_double (value));
}


static void _lambda2_ (MprisPlayer* self) {
	GVariant* variant;
	variant = _variant_new2 (xnoise_gst_player_get_volume (self->priv->xn->gPl));
	mpris_player_queue_property_for_notification (self, "Volume", variant);
	_g_variant_unref0 (variant);
}


static void __lambda2__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
	_lambda2_ (self);
}


static GVariant* _variant_new3 (const char* value) {
	return g_variant_ref_sink (g_variant_new_string (value));
}


static GVariant* _variant_new4 (char* value) {
	return g_variant_ref_sink (g_variant_new_string (value));
}


static void _lambda3_ (MprisPlayer* self) {
	char* s;
	GFile* f;
	s = g_strdup (xnoise_global_access_get_image_path_large (xnoise_global));
	if (s == NULL) {
		g_hash_table_insert (self->priv->_metadata, g_strdup ("mpris:artUrl"), _variant_new3 (""));
	}
	f = g_file_new_for_commandline_arg (s);
	if (f == NULL) {
		_g_object_unref0 (f);
		_g_free0 (s);
		return;
	}
	g_hash_table_insert (self->priv->_metadata, g_strdup ("mpris:artUrl"), _variant_new4 (g_file_get_uri (f)));
	mpris_player_trigger_metadata_update (self);
	_g_object_unref0 (f);
	_g_free0 (s);
}


static void __lambda3__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
	_lambda3_ (self);
}


static GVariant* _variant_new5 (gint64 value) {
	return g_variant_ref_sink (g_variant_new_int64 (value));
}


static gint64 _variant_get6 (GVariant* value) {
	return g_variant_get_int64 (value);
}


static GVariant* _variant_new7 (gint64 value) {
	return g_variant_ref_sink (g_variant_new_int64 (value));
}


static void _lambda4_ (MprisPlayer* self) {
	if (((GVariant*) g_hash_table_lookup (self->priv->_metadata, "mpris:length")) == NULL) {
		g_hash_table_insert (self->priv->_metadata, g_strdup ("mpris:length"), _variant_new5 ((gint64) 0));
	}
	if (_variant_get6 ((GVariant*) g_hash_table_lookup (self->priv->_metadata, "mpris:length")) != (((gint64) xnoise_gst_player_get_length_time (self->priv->xn->gPl)) / 1000)) {
		g_hash_table_insert (self->priv->_metadata, g_strdup ("mpris:length"), _variant_new7 (((gint64) xnoise_gst_player_get_length_time (self->priv->xn->gPl)) / 1000));
		mpris_player_trigger_metadata_update (self);
	}
}


static void __lambda4__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
	_lambda4_ (self);
}


MprisPlayer* mpris_player_construct (GType object_type, GDBusConnection* conn) {
	MprisPlayer * self;
	g_return_val_if_fail (conn != NULL, NULL);
	self = (MprisPlayer*) g_object_new (object_type, NULL);
	self->priv->conn = conn;
	self->priv->xn = xnoise_main_get_instance ();
	g_signal_connect_object ((GObject*) xnoise_global, "notify::track-state", (GCallback) __lambda0__g_object_notify, self, 0);
	g_signal_connect_object (xnoise_global, "tag-changed", (GCallback) _mpris_player_on_tag_changed_xnoise_global_access_tag_changed, self, 0);
	g_signal_connect_object ((GObject*) self->priv->xn->gPl, "notify::volume", (GCallback) __lambda2__g_object_notify, self, 0);
	g_signal_connect_object ((GObject*) xnoise_global, "notify::image-path-large", (GCallback) __lambda3__g_object_notify, self, 0);
	g_signal_connect_object ((GObject*) self->priv->xn->gPl, "notify::length-time", (GCallback) __lambda4__g_object_notify, self, 0);
	return self;
}


MprisPlayer* mpris_player_new (GDBusConnection* conn) {
	return mpris_player_construct (TYPE_MPRIS_PLAYER, conn);
}


static GVariant* _variant_new8 (char* value) {
	return g_variant_ref_sink (g_variant_new_string (value));
}


static gboolean _lambda1_ (MprisPlayer* self) {
	gboolean result = FALSE;
	GVariant* variant;
	variant = _variant_new8 (mpris_player_get_PlaybackStatus (self));
	mpris_player_queue_property_for_notification (self, "Metadata", variant);
	self->priv->update_metadata_source = (guint) 0;
	result = FALSE;
	_g_variant_unref0 (variant);
	return result;
}


static gboolean __lambda1__gsource_func (gpointer self) {
	gboolean result;
	result = _lambda1_ (self);
	return result;
}


static void mpris_player_trigger_metadata_update (MprisPlayer* self) {
	g_return_if_fail (self != NULL);
	if (self->priv->update_metadata_source != 0) {
		g_source_remove (self->priv->update_metadata_source);
	}
	self->priv->update_metadata_source = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 1, __lambda1__gsource_func, g_object_ref (self), g_object_unref);
}


static void _vala_array_add1 (char*** array, int* length, int* size, char* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (char*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static GVariant* _variant_new9 (char** value, gint value_length1) {
	char** _tmp2_;
	GVariantBuilder _tmp3_;
	int _tmp4_;
	_tmp2_ = value;
	g_variant_builder_init (&_tmp3_, G_VARIANT_TYPE_ARRAY);
	for (_tmp4_ = 0; _tmp4_ < value_length1; _tmp4_++) {
		g_variant_builder_add_value (&_tmp3_, g_variant_new_string (*_tmp2_));
		_tmp2_++;
	}
	return g_variant_ref_sink (g_variant_builder_end (&_tmp3_));
}


static GVariant* _variant_new10 (const char* value) {
	return g_variant_ref_sink (g_variant_new_string (value));
}


static GVariant* _variant_new11 (const char* value) {
	return g_variant_ref_sink (g_variant_new_string (value));
}


static void _vala_array_add2 (char*** array, int* length, int* size, char* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (char*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static GVariant* _variant_new12 (char** value, gint value_length1) {
	char** _tmp7_;
	GVariantBuilder _tmp8_;
	int _tmp9_;
	_tmp7_ = value;
	g_variant_builder_init (&_tmp8_, G_VARIANT_TYPE_ARRAY);
	for (_tmp9_ = 0; _tmp9_ < value_length1; _tmp9_++) {
		g_variant_builder_add_value (&_tmp8_, g_variant_new_string (*_tmp7_));
		_tmp7_++;
	}
	return g_variant_ref_sink (g_variant_builder_end (&_tmp8_));
}


static void mpris_player_on_tag_changed (MprisPlayer* self, XnoiseGlobalAccess* sender, char** newuri, const char* tagname, const char* tagvalue) {
	const char* _tmp10_;
	GQuark _tmp11_;
	static GQuark _tmp11__label0 = 0;
	static GQuark _tmp11__label1 = 0;
	static GQuark _tmp11__label2 = 0;
	static GQuark _tmp11__label3 = 0;
	g_return_if_fail (self != NULL);
	g_return_if_fail (sender != NULL);
	_tmp10_ = tagname;
	_tmp11_ = (NULL == _tmp10_) ? 0 : g_quark_from_string (_tmp10_);
	if (_tmp11_ == ((0 != _tmp11__label0) ? _tmp11__label0 : (_tmp11__label0 = g_quark_from_static_string ("artist"))))
	switch (0) {
		default:
		{
			gint sa_length1;
			gint _sa_size_;
			char** _tmp1_;
			char** _tmp0_ = NULL;
			char** sa;
			if (tagvalue == NULL) {
				break;
			}
			sa = (_tmp1_ = (_tmp0_ = g_new0 (char*, 0 + 1), _tmp0_), sa_length1 = 0, _sa_size_ = sa_length1, _tmp1_);
			_vala_array_add1 (&sa, &sa_length1, &_sa_size_, g_strdup (tagvalue));
			g_hash_table_insert (self->priv->_metadata, g_strdup ("xesam:artist"), _variant_new9 (sa, sa_length1));
			sa = (_vala_array_free (sa, sa_length1, (GDestroyNotify) g_free), NULL);
			break;
		}
	} else if (_tmp11_ == ((0 != _tmp11__label1) ? _tmp11__label1 : (_tmp11__label1 = g_quark_from_static_string ("album"))))
	switch (0) {
		default:
		{
			char* s;
			if (tagvalue == NULL) {
				break;
			}
			s = g_strdup (tagvalue);
			g_hash_table_insert (self->priv->_metadata, g_strdup ("xesam:album"), _variant_new10 (s));
			_g_free0 (s);
			break;
		}
	} else if (_tmp11_ == ((0 != _tmp11__label2) ? _tmp11__label2 : (_tmp11__label2 = g_quark_from_static_string ("title"))))
	switch (0) {
		default:
		{
			char* s;
			if (tagvalue == NULL) {
				break;
			}
			s = g_strdup (tagvalue);
			g_hash_table_insert (self->priv->_metadata, g_strdup ("xesam:title"), _variant_new11 (s));
			_g_free0 (s);
			break;
		}
	} else if (_tmp11_ == ((0 != _tmp11__label3) ? _tmp11__label3 : (_tmp11__label3 = g_quark_from_static_string ("genre"))))
	switch (0) {
		default:
		{
			gint sa_length1;
			gint _sa_size_;
			char** _tmp6_;
			char** _tmp5_ = NULL;
			char** sa;
			if (tagvalue == NULL) {
				break;
			}
			sa = (_tmp6_ = (_tmp5_ = g_new0 (char*, 0 + 1), _tmp5_), sa_length1 = 0, _sa_size_ = sa_length1, _tmp6_);
			_vala_array_add2 (&sa, &sa_length1, &_sa_size_, g_strdup (tagvalue));
			g_hash_table_insert (self->priv->_metadata, g_strdup ("xesam:genre"), _variant_new12 (sa, sa_length1));
			sa = (_vala_array_free (sa, sa_length1, (GDestroyNotify) g_free), NULL);
			break;
		}
	} else
	switch (0) {
		default:
		{
			break;
		}
	}
	mpris_player_trigger_metadata_update (self);
}


static gpointer _g_variant_ref0 (gpointer self) {
	return self ? g_variant_ref (self) : NULL;
}


static gboolean mpris_player_send_property_change (MprisPlayer* self) {
	gboolean result = FALSE;
	GVariantBuilder* builder;
	GVariantType* _tmp0_;
	GVariantBuilder* _tmp1_;
	GVariantBuilder* invalidated_builder;
	GHashTable* _tmp2_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	if (self->priv->changed_properties == NULL) {
		result = FALSE;
		return result;
	}
	builder = g_variant_builder_new (G_VARIANT_TYPE_ARRAY);
	invalidated_builder = (_tmp1_ = g_variant_builder_new (_tmp0_ = g_variant_type_new ("as")), _g_variant_type_free0 (_tmp0_), _tmp1_);
	{
		GList* name_collection;
		GList* name_it;
		name_collection = g_hash_table_get_keys (self->priv->changed_properties);
		for (name_it = name_collection; name_it != NULL; name_it = name_it->next) {
			char* name;
			name = g_strdup ((const char*) name_it->data);
			{
				GVariant* variant;
				variant = _g_variant_ref0 ((GVariant*) g_hash_table_lookup (self->priv->changed_properties, name));
				g_variant_builder_add (builder, "{sv}", name, variant, NULL);
				_g_variant_unref0 (variant);
				_g_free0 (name);
			}
		}
		_g_list_free0 (name_collection);
	}
	self->priv->changed_properties = (_tmp2_ = NULL, _g_hash_table_unref0 (self->priv->changed_properties), _tmp2_);
	{
		GVariant* _tmp3_;
		g_dbus_connection_emit_signal (self->priv->conn, NULL, "/org/mpris/MediaPlayer2", "org.freedesktop.DBus.Properties", "PropertiesChanged", _tmp3_ = g_variant_ref_sink (g_variant_new ("(sa{sv}as)", MPRIS_PLAYER_INTERFACE_NAME, builder, invalidated_builder, NULL)), &_inner_error_);
		_g_variant_unref0 (_tmp3_);
		if (_inner_error_ != NULL) {
			goto __catch2_g_error;
		}
	}
	goto __finally2;
	__catch2_g_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
			g_print ("%s\n", e->message);
			_g_error_free0 (e);
		}
	}
	__finally2:
	if (_inner_error_ != NULL) {
		_g_variant_builder_unref0 (invalidated_builder);
		_g_variant_builder_unref0 (builder);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
	self->priv->send_property_source = (guint) 0;
	result = FALSE;
	_g_variant_builder_unref0 (invalidated_builder);
	_g_variant_builder_unref0 (builder);
	return result;
}


static gboolean _mpris_player_send_property_change_gsource_func (gpointer self) {
	gboolean result;
	result = mpris_player_send_property_change (self);
	return result;
}


static void mpris_player_queue_property_for_notification (MprisPlayer* self, const char* property, GVariant* val) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (property != NULL);
	g_return_if_fail (val != NULL);
	if (self->priv->changed_properties == NULL) {
		GHashTable* _tmp0_;
		self->priv->changed_properties = (_tmp0_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, g_variant_unref), _g_hash_table_unref0 (self->priv->changed_properties), _tmp0_);
	}
	g_hash_table_insert (self->priv->changed_properties, g_strdup (property), _g_variant_ref0 (val));
	if (self->priv->send_property_source == 0) {
		self->priv->send_property_source = g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, _mpris_player_send_property_change_gsource_func, g_object_ref (self), g_object_unref);
	}
}


void mpris_player_Next (MprisPlayer* self) {
	g_return_if_fail (self != NULL);
	xnoise_main_window_change_track (self->priv->xn->main_window, XNOISE_CONTROL_BUTTON_DIRECTION_NEXT, FALSE);
}


void mpris_player_Previous (MprisPlayer* self) {
	g_return_if_fail (self != NULL);
	xnoise_main_window_change_track (self->priv->xn->main_window, XNOISE_CONTROL_BUTTON_DIRECTION_PREVIOUS, FALSE);
}


void mpris_player_Pause (MprisPlayer* self) {
	g_return_if_fail (self != NULL);
	if (xnoise_global_access_get_current_uri (xnoise_global) == NULL) {
		char* uri;
		gboolean _tmp0_ = FALSE;
		uri = xnoise_track_list_model_get_uri_for_current_position (self->priv->xn->tl->tracklistmodel);
		if (_vala_strcmp0 (uri, "") != 0) {
			_tmp0_ = uri != NULL;
		} else {
			_tmp0_ = FALSE;
		}
		if (_tmp0_) {
			xnoise_global_access_set_current_uri (xnoise_global, uri);
		}
		_g_free0 (uri);
	}
	xnoise_global_access_set_track_state (xnoise_global, XNOISE_GLOBAL_ACCESS_TRACK_STATE_PAUSED);
}


void mpris_player_PlayPause (MprisPlayer* self) {
	g_return_if_fail (self != NULL);
	if (xnoise_global_access_get_current_uri (xnoise_global) == NULL) {
		char* uri;
		gboolean _tmp0_ = FALSE;
		uri = xnoise_track_list_model_get_uri_for_current_position (self->priv->xn->tl->tracklistmodel);
		if (_vala_strcmp0 (uri, "") != 0) {
			_tmp0_ = uri != NULL;
		} else {
			_tmp0_ = FALSE;
		}
		if (_tmp0_) {
			xnoise_global_access_set_current_uri (xnoise_global, uri);
		}
		_g_free0 (uri);
	}
	if (xnoise_global_access_get_track_state (xnoise_global) == XNOISE_GLOBAL_ACCESS_TRACK_STATE_PLAYING) {
		xnoise_global_access_set_track_state (xnoise_global, XNOISE_GLOBAL_ACCESS_TRACK_STATE_PAUSED);
	} else {
		xnoise_global_access_set_track_state (xnoise_global, XNOISE_GLOBAL_ACCESS_TRACK_STATE_PLAYING);
	}
}


void mpris_player_Stop (MprisPlayer* self) {
	g_return_if_fail (self != NULL);
	xnoise_main_window_stop (self->priv->xn->main_window);
}


void mpris_player_Play (MprisPlayer* self) {
	g_return_if_fail (self != NULL);
	if (xnoise_global_access_get_current_uri (xnoise_global) == NULL) {
		char* uri;
		gboolean _tmp0_ = FALSE;
		uri = xnoise_track_list_model_get_uri_for_current_position (self->priv->xn->tl->tracklistmodel);
		if (_vala_strcmp0 (uri, "") != 0) {
			_tmp0_ = uri != NULL;
		} else {
			_tmp0_ = FALSE;
		}
		if (_tmp0_) {
			xnoise_global_access_set_current_uri (xnoise_global, uri);
		}
		_g_free0 (uri);
	}
	if (!(xnoise_global_access_get_track_state (xnoise_global) == XNOISE_GLOBAL_ACCESS_TRACK_STATE_PLAYING)) {
		xnoise_global_access_set_track_state (xnoise_global, XNOISE_GLOBAL_ACCESS_TRACK_STATE_PLAYING);
	}
}


void mpris_player_Seek (MprisPlayer* self, gint64 Offset) {
	g_return_if_fail (self != NULL);
	return;
}


void mpris_player_SetPosition (MprisPlayer* self, const char* dobj, gint64 Position) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (dobj != NULL);
	g_print (" set position %lf\n", ((double) Position) / (xnoise_gst_player_get_length_time (self->priv->xn->gPl) / 1000.0));
	xnoise_gst_player_set_gst_position (self->priv->xn->gPl, ((double) Position) / (xnoise_gst_player_get_length_time (self->priv->xn->gPl) / 1000.0));
}


void mpris_player_OpenUri (MprisPlayer* self, const char* Uri) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (Uri != NULL);
	return;
}


char* mpris_player_get_PlaybackStatus (MprisPlayer* self) {
	char* result;
	g_return_val_if_fail (self != NULL, NULL);
	switch (xnoise_global_access_get_track_state (xnoise_global)) {
		case XNOISE_GLOBAL_ACCESS_TRACK_STATE_STOPPED:
		{
			result = g_strdup ("Stopped");
			return result;
		}
		case XNOISE_GLOBAL_ACCESS_TRACK_STATE_PLAYING:
		{
			result = g_strdup ("Playing");
			return result;
		}
		case XNOISE_GLOBAL_ACCESS_TRACK_STATE_PAUSED:
		{
			result = g_strdup ("Paused");
			return result;
		}
		default:
		{
			result = g_strdup ("Stopped");
			return result;
		}
	}
}


char* mpris_player_get_LoopStatus (MprisPlayer* self) {
	char* result;
	g_return_val_if_fail (self != NULL, NULL);
	switch (xnoise_main_window_get_repeatState (self->priv->xn->main_window)) {
		case XNOISE_MAIN_WINDOW_REPEAT_NOT_AT_ALL:
		{
			result = g_strdup ("None");
			return result;
		}
		case XNOISE_MAIN_WINDOW_REPEAT_SINGLE:
		{
			result = g_strdup ("Track");
			return result;
		}
		case XNOISE_MAIN_WINDOW_REPEAT_ALL:
		{
			result = g_strdup ("Playlist");
			return result;
		}
		case XNOISE_MAIN_WINDOW_REPEAT_RANDOM:
		{
			result = g_strdup ("Playlist");
			return result;
		}
		default:
		{
			result = g_strdup ("Playlist");
			return result;
		}
	}
}


static GVariant* _variant_new13 (const char* value) {
	return g_variant_ref_sink (g_variant_new_string (value));
}


void mpris_player_set_LoopStatus (MprisPlayer* self, const char* value) {
	const char* _tmp0_;
	GQuark _tmp1_;
	static GQuark _tmp1__label0 = 0;
	static GQuark _tmp1__label1 = 0;
	static GQuark _tmp1__label2 = 0;
	GVariant* variant;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
	if (_tmp1_ == ((0 != _tmp1__label0) ? _tmp1__label0 : (_tmp1__label0 = g_quark_from_static_string ("None"))))
	switch (0) {
		default:
		{
			xnoise_main_window_set_repeatState (self->priv->xn->main_window, XNOISE_MAIN_WINDOW_REPEAT_NOT_AT_ALL);
			break;
		}
	} else if (_tmp1_ == ((0 != _tmp1__label1) ? _tmp1__label1 : (_tmp1__label1 = g_quark_from_static_string ("Track"))))
	switch (0) {
		default:
		{
			xnoise_main_window_set_repeatState (self->priv->xn->main_window, XNOISE_MAIN_WINDOW_REPEAT_SINGLE);
			break;
		}
	} else if (_tmp1_ == ((0 != _tmp1__label2) ? _tmp1__label2 : (_tmp1__label2 = g_quark_from_static_string ("Playlist"))))
	switch (0) {
		default:
		{
			xnoise_main_window_set_repeatState (self->priv->xn->main_window, XNOISE_MAIN_WINDOW_REPEAT_ALL);
			break;
		}
	} else
	switch (0) {
		default:
		{
			xnoise_main_window_set_repeatState (self->priv->xn->main_window, XNOISE_MAIN_WINDOW_REPEAT_ALL);
			break;
		}
	}
	variant = _variant_new13 (value);
	mpris_player_queue_property_for_notification (self, "LoopStatus", variant);
	_g_variant_unref0 (variant);
	g_object_notify ((GObject *) self, "LoopStatus");
}


double mpris_player_get_Rate (MprisPlayer* self) {
	double result;
	g_return_val_if_fail (self != NULL, 0.0);
	result = 1.0;
	return result;
}


void mpris_player_set_Rate (MprisPlayer* self, double value) {
	g_return_if_fail (self != NULL);
	g_object_notify ((GObject *) self, "Rate");
}


gboolean mpris_player_get_Shuffle (MprisPlayer* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	if (xnoise_main_window_get_repeatState (self->priv->xn->main_window) == XNOISE_MAIN_WINDOW_REPEAT_RANDOM) {
		result = TRUE;
		return result;
	}
	result = FALSE;
	return result;
}


static GVariant* _variant_new14 (gboolean value) {
	return g_variant_ref_sink (g_variant_new_boolean (value));
}


void mpris_player_set_Shuffle (MprisPlayer* self, gboolean value) {
	GVariant* variant;
	g_return_if_fail (self != NULL);
	if (value == TRUE) {
		self->priv->buffer_repeat_state = xnoise_main_window_get_repeatState (self->priv->xn->main_window);
		xnoise_main_window_set_repeatState (self->priv->xn->main_window, XNOISE_MAIN_WINDOW_REPEAT_RANDOM);
	} else {
		xnoise_main_window_set_repeatState (self->priv->xn->main_window, self->priv->buffer_repeat_state);
	}
	variant = _variant_new14 (value);
	mpris_player_queue_property_for_notification (self, "Shuffle", variant);
	_g_variant_unref0 (variant);
	g_object_notify ((GObject *) self, "Shuffle");
}


static GVariant* _variant_new15 (const char* value) {
	return g_variant_ref_sink (g_variant_new_string (value));
}


static gpointer _g_hash_table_ref0 (gpointer self) {
	return self ? g_hash_table_ref (self) : NULL;
}


GHashTable* mpris_player_get_Metadata (MprisPlayer* self) {
	GHashTable* result;
	GVariant* variant;
	g_return_val_if_fail (self != NULL, NULL);
	variant = _variant_new15 ("1");
	g_hash_table_insert (self->priv->_metadata, g_strdup ("mpris:trackid"), _g_variant_ref0 (variant));
	result = _g_hash_table_ref0 (self->priv->_metadata);
	_g_variant_unref0 (variant);
	return result;
}


double mpris_player_get_Volume (MprisPlayer* self) {
	double result;
	g_return_val_if_fail (self != NULL, 0.0);
	result = xnoise_gst_player_get_volume (self->priv->xn->gPl);
	return result;
}


void mpris_player_set_Volume (MprisPlayer* self, double value) {
	g_return_if_fail (self != NULL);
	if (value < 0.0) {
		value = 0.0;
	}
	if (value > 1.0) {
		value = 1.0;
	}
	xnoise_gst_player_set_volume (self->priv->xn->gPl, value);
	g_object_notify ((GObject *) self, "Volume");
}


gint64 mpris_player_get_Position (MprisPlayer* self) {
	gint64 result;
	double pos;
	g_return_val_if_fail (self != NULL, 0LL);
	g_print ("get position\n");
	if (xnoise_gst_player_get_length_time (self->priv->xn->gPl) == 0) {
		result = (gint64) (-1);
		return result;
	}
	pos = xnoise_gst_player_get_gst_position (self->priv->xn->gPl);
	result = (gint64) ((pos * xnoise_gst_player_get_length_time (self->priv->xn->gPl)) / 1000.0);
	return result;
}


double mpris_player_get_MinimumRate (MprisPlayer* self) {
	double result;
	g_return_val_if_fail (self != NULL, 0.0);
	result = 1.0;
	return result;
}


double mpris_player_get_MaximumRate (MprisPlayer* self) {
	double result;
	g_return_val_if_fail (self != NULL, 0.0);
	result = 1.0;
	return result;
}


gboolean mpris_player_get_CanGoNext (MprisPlayer* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = TRUE;
	return result;
}


gboolean mpris_player_get_CanGoPrevious (MprisPlayer* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = TRUE;
	return result;
}


gboolean mpris_player_get_CanPlay (MprisPlayer* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = TRUE;
	return result;
}


gboolean mpris_player_get_CanPause (MprisPlayer* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = TRUE;
	return result;
}


gboolean mpris_player_get_CanSeek (MprisPlayer* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = TRUE;
	return result;
}


gboolean mpris_player_get_CanControl (MprisPlayer* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = TRUE;
	return result;
}


static void mpris_player_class_init (MprisPlayerClass * klass) {
	mpris_player_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (MprisPlayerPrivate));
	G_OBJECT_CLASS (klass)->get_property = mpris_player_get_property;
	G_OBJECT_CLASS (klass)->set_property = mpris_player_set_property;
	G_OBJECT_CLASS (klass)->finalize = mpris_player_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_PLAYER_PLAYBACK_STATUS, g_param_spec_string ("PlaybackStatus", "PlaybackStatus", "PlaybackStatus", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_PLAYER_LOOP_STATUS, g_param_spec_string ("LoopStatus", "LoopStatus", "LoopStatus", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_PLAYER_RATE, g_param_spec_double ("Rate", "Rate", "Rate", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_PLAYER_SHUFFLE, g_param_spec_boolean ("Shuffle", "Shuffle", "Shuffle", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_PLAYER_METADATA, g_param_spec_boxed ("Metadata", "Metadata", "Metadata", G_TYPE_HASH_TABLE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_PLAYER_VOLUME, g_param_spec_double ("Volume", "Volume", "Volume", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_PLAYER_POSITION, g_param_spec_int64 ("Position", "Position", "Position", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_PLAYER_MINIMUM_RATE, g_param_spec_double ("MinimumRate", "MinimumRate", "MinimumRate", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_PLAYER_MAXIMUM_RATE, g_param_spec_double ("MaximumRate", "MaximumRate", "MaximumRate", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_PLAYER_CAN_GO_NEXT, g_param_spec_boolean ("CanGoNext", "CanGoNext", "CanGoNext", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_PLAYER_CAN_GO_PREVIOUS, g_param_spec_boolean ("CanGoPrevious", "CanGoPrevious", "CanGoPrevious", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_PLAYER_CAN_PLAY, g_param_spec_boolean ("CanPlay", "CanPlay", "CanPlay", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_PLAYER_CAN_PAUSE, g_param_spec_boolean ("CanPause", "CanPause", "CanPause", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_PLAYER_CAN_SEEK, g_param_spec_boolean ("CanSeek", "CanSeek", "CanSeek", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_PLAYER_CAN_CONTROL, g_param_spec_boolean ("CanControl", "CanControl", "CanControl", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_signal_new ("seeked", TYPE_MPRIS_PLAYER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT64, G_TYPE_NONE, 1, G_TYPE_INT64);
}


static void mpris_player_instance_init (MprisPlayer * self) {
	self->priv = MPRIS_PLAYER_GET_PRIVATE (self);
	self->priv->send_property_source = (guint) 0;
	self->priv->update_metadata_source = (guint) 0;
	self->priv->changed_properties = NULL;
	self->priv->buffer_repeat_state = XNOISE_MAIN_WINDOW_REPEAT_NOT_AT_ALL;
	self->priv->_metadata = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, g_variant_unref);
}


static void mpris_player_finalize (GObject* obj) {
	MprisPlayer * self;
	self = MPRIS_PLAYER (obj);
	_g_hash_table_unref0 (self->priv->changed_properties);
	_g_hash_table_unref0 (self->priv->_metadata);
	G_OBJECT_CLASS (mpris_player_parent_class)->finalize (obj);
}


GType mpris_player_get_type (void) {
	return mpris_player_type_id;
}


GType mpris_player_register_type (GTypeModule * module) {
	static const GTypeInfo g_define_type_info = { sizeof (MprisPlayerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) mpris_player_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MprisPlayer), 0, (GInstanceInitFunc) mpris_player_instance_init, NULL };
	mpris_player_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "MprisPlayer", &g_define_type_info, 0);
	return mpris_player_type_id;
}


static void mpris_player_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	MprisPlayer * self;
	self = MPRIS_PLAYER (object);
	switch (property_id) {
		case MPRIS_PLAYER_PLAYBACK_STATUS:
		g_value_take_string (value, mpris_player_get_PlaybackStatus (self));
		break;
		case MPRIS_PLAYER_LOOP_STATUS:
		g_value_take_string (value, mpris_player_get_LoopStatus (self));
		break;
		case MPRIS_PLAYER_RATE:
		g_value_set_double (value, mpris_player_get_Rate (self));
		break;
		case MPRIS_PLAYER_SHUFFLE:
		g_value_set_boolean (value, mpris_player_get_Shuffle (self));
		break;
		case MPRIS_PLAYER_METADATA:
		g_value_take_boxed (value, mpris_player_get_Metadata (self));
		break;
		case MPRIS_PLAYER_VOLUME:
		g_value_set_double (value, mpris_player_get_Volume (self));
		break;
		case MPRIS_PLAYER_POSITION:
		g_value_set_int64 (value, mpris_player_get_Position (self));
		break;
		case MPRIS_PLAYER_MINIMUM_RATE:
		g_value_set_double (value, mpris_player_get_MinimumRate (self));
		break;
		case MPRIS_PLAYER_MAXIMUM_RATE:
		g_value_set_double (value, mpris_player_get_MaximumRate (self));
		break;
		case MPRIS_PLAYER_CAN_GO_NEXT:
		g_value_set_boolean (value, mpris_player_get_CanGoNext (self));
		break;
		case MPRIS_PLAYER_CAN_GO_PREVIOUS:
		g_value_set_boolean (value, mpris_player_get_CanGoPrevious (self));
		break;
		case MPRIS_PLAYER_CAN_PLAY:
		g_value_set_boolean (value, mpris_player_get_CanPlay (self));
		break;
		case MPRIS_PLAYER_CAN_PAUSE:
		g_value_set_boolean (value, mpris_player_get_CanPause (self));
		break;
		case MPRIS_PLAYER_CAN_SEEK:
		g_value_set_boolean (value, mpris_player_get_CanSeek (self));
		break;
		case MPRIS_PLAYER_CAN_CONTROL:
		g_value_set_boolean (value, mpris_player_get_CanControl (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void mpris_player_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	MprisPlayer * self;
	self = MPRIS_PLAYER (object);
	switch (property_id) {
		case MPRIS_PLAYER_LOOP_STATUS:
		mpris_player_set_LoopStatus (self, g_value_get_string (value));
		break;
		case MPRIS_PLAYER_RATE:
		mpris_player_set_Rate (self, g_value_get_double (value));
		break;
		case MPRIS_PLAYER_SHUFFLE:
		mpris_player_set_Shuffle (self, g_value_get_boolean (value));
		break;
		case MPRIS_PLAYER_VOLUME:
		mpris_player_set_Volume (self, g_value_get_double (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _dbus_mpris_player_Next (MprisPlayer* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error;
	GVariantIter _arguments_iter;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	error = NULL;
	g_variant_iter_init (&_arguments_iter, parameters);
	mpris_player_Next (self);
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_method_invocation_return_value (invocation, _reply);
}


static void _dbus_mpris_player_Previous (MprisPlayer* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error;
	GVariantIter _arguments_iter;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	error = NULL;
	g_variant_iter_init (&_arguments_iter, parameters);
	mpris_player_Previous (self);
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_method_invocation_return_value (invocation, _reply);
}


static void _dbus_mpris_player_Pause (MprisPlayer* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error;
	GVariantIter _arguments_iter;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	error = NULL;
	g_variant_iter_init (&_arguments_iter, parameters);
	mpris_player_Pause (self);
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_method_invocation_return_value (invocation, _reply);
}


static void _dbus_mpris_player_PlayPause (MprisPlayer* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error;
	GVariantIter _arguments_iter;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	error = NULL;
	g_variant_iter_init (&_arguments_iter, parameters);
	mpris_player_PlayPause (self);
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_method_invocation_return_value (invocation, _reply);
}


static void _dbus_mpris_player_Stop (MprisPlayer* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error;
	GVariantIter _arguments_iter;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	error = NULL;
	g_variant_iter_init (&_arguments_iter, parameters);
	mpris_player_Stop (self);
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_method_invocation_return_value (invocation, _reply);
}


static void _dbus_mpris_player_Play (MprisPlayer* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error;
	GVariantIter _arguments_iter;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	error = NULL;
	g_variant_iter_init (&_arguments_iter, parameters);
	mpris_player_Play (self);
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_method_invocation_return_value (invocation, _reply);
}


static void _dbus_mpris_player_Seek (MprisPlayer* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error;
	gint64 Offset = 0LL;
	GVariant* _tmp6_;
	GVariantIter _arguments_iter;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	error = NULL;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp6_ = g_variant_iter_next_value (&_arguments_iter);
	Offset = g_variant_get_int64 (_tmp6_);
	g_variant_unref (_tmp6_);
	mpris_player_Seek (self, Offset);
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_method_invocation_return_value (invocation, _reply);
}


static void _dbus_mpris_player_SetPosition (MprisPlayer* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error;
	char* dobj = NULL;
	GVariant* _tmp7_;
	gint64 Position = 0LL;
	GVariant* _tmp8_;
	GVariantIter _arguments_iter;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	error = NULL;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp7_ = g_variant_iter_next_value (&_arguments_iter);
	dobj = g_variant_dup_string (_tmp7_, NULL);
	g_variant_unref (_tmp7_);
	_tmp8_ = g_variant_iter_next_value (&_arguments_iter);
	Position = g_variant_get_int64 (_tmp8_);
	g_variant_unref (_tmp8_);
	mpris_player_SetPosition (self, dobj, Position);
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_g_free0 (dobj);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_method_invocation_return_value (invocation, _reply);
}


static void _dbus_mpris_player_OpenUri (MprisPlayer* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error;
	char* Uri = NULL;
	GVariant* _tmp9_;
	GVariantIter _arguments_iter;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	error = NULL;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp9_ = g_variant_iter_next_value (&_arguments_iter);
	Uri = g_variant_dup_string (_tmp9_, NULL);
	g_variant_unref (_tmp9_);
	mpris_player_OpenUri (self, Uri);
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_g_free0 (Uri);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_method_invocation_return_value (invocation, _reply);
}


static void mpris_player_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "Next") == 0) {
		_dbus_mpris_player_Next (object, parameters, invocation);
	} else if (strcmp (method_name, "Previous") == 0) {
		_dbus_mpris_player_Previous (object, parameters, invocation);
	} else if (strcmp (method_name, "Pause") == 0) {
		_dbus_mpris_player_Pause (object, parameters, invocation);
	} else if (strcmp (method_name, "PlayPause") == 0) {
		_dbus_mpris_player_PlayPause (object, parameters, invocation);
	} else if (strcmp (method_name, "Stop") == 0) {
		_dbus_mpris_player_Stop (object, parameters, invocation);
	} else if (strcmp (method_name, "Play") == 0) {
		_dbus_mpris_player_Play (object, parameters, invocation);
	} else if (strcmp (method_name, "Seek") == 0) {
		_dbus_mpris_player_Seek (object, parameters, invocation);
	} else if (strcmp (method_name, "SetPosition") == 0) {
		_dbus_mpris_player_SetPosition (object, parameters, invocation);
	} else if (strcmp (method_name, "OpenUri") == 0) {
		_dbus_mpris_player_OpenUri (object, parameters, invocation);
	}
}


static GVariant* _dbus_mpris_player_get_PlaybackStatus (MprisPlayer* self) {
	char* result;
	GVariant* _reply;
	result = mpris_player_get_PlaybackStatus (self);
	_reply = g_variant_new_string (result);
	_g_free0 (result);
	return _reply;
}


static GVariant* _dbus_mpris_player_get_LoopStatus (MprisPlayer* self) {
	char* result;
	GVariant* _reply;
	result = mpris_player_get_LoopStatus (self);
	_reply = g_variant_new_string (result);
	_g_free0 (result);
	return _reply;
}


static GVariant* _dbus_mpris_player_get_Rate (MprisPlayer* self) {
	double result;
	GVariant* _reply;
	result = mpris_player_get_Rate (self);
	_reply = g_variant_new_double (result);
	return _reply;
}


static GVariant* _dbus_mpris_player_get_Shuffle (MprisPlayer* self) {
	gboolean result;
	GVariant* _reply;
	result = mpris_player_get_Shuffle (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}


static GVariant* _dbus_mpris_player_get_Metadata (MprisPlayer* self) {
	GHashTable* result;
	GVariant* _reply;
	GVariantBuilder _tmp10_;
	GHashTableIter _tmp11_;
	gpointer _tmp12_, _tmp13_;
	result = mpris_player_get_Metadata (self);
	g_hash_table_iter_init (&_tmp11_, result);
	g_variant_builder_init (&_tmp10_, G_VARIANT_TYPE_DICTIONARY);
	while (g_hash_table_iter_next (&_tmp11_, &_tmp12_, &_tmp13_)) {
		char* _key;
		GVariant* _value;
		_key = (char*) _tmp12_;
		_value = (GVariant*) _tmp13_;
		g_variant_builder_add (&_tmp10_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
	}
	_reply = g_variant_builder_end (&_tmp10_);
	_g_hash_table_unref0 (result);
	return _reply;
}


static GVariant* _dbus_mpris_player_get_Volume (MprisPlayer* self) {
	double result;
	GVariant* _reply;
	result = mpris_player_get_Volume (self);
	_reply = g_variant_new_double (result);
	return _reply;
}


static GVariant* _dbus_mpris_player_get_Position (MprisPlayer* self) {
	gint64 result;
	GVariant* _reply;
	result = mpris_player_get_Position (self);
	_reply = g_variant_new_int64 (result);
	return _reply;
}


static GVariant* _dbus_mpris_player_get_MinimumRate (MprisPlayer* self) {
	double result;
	GVariant* _reply;
	result = mpris_player_get_MinimumRate (self);
	_reply = g_variant_new_double (result);
	return _reply;
}


static GVariant* _dbus_mpris_player_get_MaximumRate (MprisPlayer* self) {
	double result;
	GVariant* _reply;
	result = mpris_player_get_MaximumRate (self);
	_reply = g_variant_new_double (result);
	return _reply;
}


static GVariant* _dbus_mpris_player_get_CanGoNext (MprisPlayer* self) {
	gboolean result;
	GVariant* _reply;
	result = mpris_player_get_CanGoNext (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}


static GVariant* _dbus_mpris_player_get_CanGoPrevious (MprisPlayer* self) {
	gboolean result;
	GVariant* _reply;
	result = mpris_player_get_CanGoPrevious (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}


static GVariant* _dbus_mpris_player_get_CanPlay (MprisPlayer* self) {
	gboolean result;
	GVariant* _reply;
	result = mpris_player_get_CanPlay (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}


static GVariant* _dbus_mpris_player_get_CanPause (MprisPlayer* self) {
	gboolean result;
	GVariant* _reply;
	result = mpris_player_get_CanPause (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}


static GVariant* _dbus_mpris_player_get_CanSeek (MprisPlayer* self) {
	gboolean result;
	GVariant* _reply;
	result = mpris_player_get_CanSeek (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}


static GVariant* _dbus_mpris_player_get_CanControl (MprisPlayer* self) {
	gboolean result;
	GVariant* _reply;
	result = mpris_player_get_CanControl (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}


static GVariant* mpris_player_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (property_name, "PlaybackStatus") == 0) {
		return _dbus_mpris_player_get_PlaybackStatus (object);
	} else if (strcmp (property_name, "LoopStatus") == 0) {
		return _dbus_mpris_player_get_LoopStatus (object);
	} else if (strcmp (property_name, "Rate") == 0) {
		return _dbus_mpris_player_get_Rate (object);
	} else if (strcmp (property_name, "Shuffle") == 0) {
		return _dbus_mpris_player_get_Shuffle (object);
	} else if (strcmp (property_name, "Metadata") == 0) {
		return _dbus_mpris_player_get_Metadata (object);
	} else if (strcmp (property_name, "Volume") == 0) {
		return _dbus_mpris_player_get_Volume (object);
	} else if (strcmp (property_name, "Position") == 0) {
		return _dbus_mpris_player_get_Position (object);
	} else if (strcmp (property_name, "MinimumRate") == 0) {
		return _dbus_mpris_player_get_MinimumRate (object);
	} else if (strcmp (property_name, "MaximumRate") == 0) {
		return _dbus_mpris_player_get_MaximumRate (object);
	} else if (strcmp (property_name, "CanGoNext") == 0) {
		return _dbus_mpris_player_get_CanGoNext (object);
	} else if (strcmp (property_name, "CanGoPrevious") == 0) {
		return _dbus_mpris_player_get_CanGoPrevious (object);
	} else if (strcmp (property_name, "CanPlay") == 0) {
		return _dbus_mpris_player_get_CanPlay (object);
	} else if (strcmp (property_name, "CanPause") == 0) {
		return _dbus_mpris_player_get_CanPause (object);
	} else if (strcmp (property_name, "CanSeek") == 0) {
		return _dbus_mpris_player_get_CanSeek (object);
	} else if (strcmp (property_name, "CanControl") == 0) {
		return _dbus_mpris_player_get_CanControl (object);
	}
	return NULL;
}


static void _dbus_mpris_player_set_LoopStatus (MprisPlayer* self, GVariant* _value) {
	char* value = NULL;
	value = g_variant_dup_string (_value, NULL);
	mpris_player_set_LoopStatus (self, value);
	_g_free0 (value);
}


static void _dbus_mpris_player_set_Rate (MprisPlayer* self, GVariant* _value) {
	double value = 0.0;
	value = g_variant_get_double (_value);
	mpris_player_set_Rate (self, value);
}


static void _dbus_mpris_player_set_Shuffle (MprisPlayer* self, GVariant* _value) {
	gboolean value = FALSE;
	value = g_variant_get_boolean (_value);
	mpris_player_set_Shuffle (self, value);
}


static void _dbus_mpris_player_set_Volume (MprisPlayer* self, GVariant* _value) {
	double value = 0.0;
	value = g_variant_get_double (_value);
	mpris_player_set_Volume (self, value);
}


static gboolean mpris_player_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (property_name, "LoopStatus") == 0) {
		_dbus_mpris_player_set_LoopStatus (object, value);
		return TRUE;
	} else if (strcmp (property_name, "Rate") == 0) {
		_dbus_mpris_player_set_Rate (object, value);
		return TRUE;
	} else if (strcmp (property_name, "Shuffle") == 0) {
		_dbus_mpris_player_set_Shuffle (object, value);
		return TRUE;
	} else if (strcmp (property_name, "Volume") == 0) {
		_dbus_mpris_player_set_Volume (object, value);
		return TRUE;
	}
	return FALSE;
}


static void _dbus_mpris_player_seeked (GObject* _sender, gint64 Position, gpointer* _data) {
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_int64 (Position));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.mpris.MediaPlayer2.Player", "Seeked", _arguments, NULL);
}


guint mpris_player_register_object (gpointer object, GDBusConnection* connection, const gchar* path, GError** error) {
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, &_mpris_player_dbus_interface_info, &_mpris_player_dbus_interface_vtable, data, _mpris_player_unregister_object, error);
	if (!result) {
		return 0;
	}
	g_signal_connect (object, "seeked", (GCallback) _dbus_mpris_player_seeked, data);
	return result;
}


static void _mpris_player_unregister_object (gpointer user_data) {
	gpointer* data;
	data = user_data;
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}



static void g_cclosure_user_marshal_VOID__INT64 (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__INT64) (gpointer data1, gint64 arg_1, gpointer data2);
	register GMarshalFunc_VOID__INT64 callback;
	register GCClosure * cc;
	register gpointer data1, data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 2);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__INT64) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_int64 (param_values + 1), data2);
}



